"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const shared = require("@volar/shared");
const rename_1 = require("./rename");
function register(languageService, getTextDocument, settings) {
    return (oldUri, newUri) => __awaiter(this, void 0, void 0, function* () {
        var _a, _b, _c, _d;
        const document = getTextDocument(oldUri);
        const [formatOptions, preferences] = document ? yield Promise.all([
            (_b = (_a = settings.getFormatOptions) === null || _a === void 0 ? void 0 : _a.call(settings, document.uri)) !== null && _b !== void 0 ? _b : {},
            (_d = (_c = settings.getPreferences) === null || _c === void 0 ? void 0 : _c.call(settings, document.uri)) !== null && _d !== void 0 ? _d : {},
        ]) : [{}, {}];
        const fileToRename = shared.uriToFsPath(oldUri);
        const newFilePath = shared.uriToFsPath(newUri);
        let response;
        try {
            response = languageService.getEditsForFileRename(fileToRename, newFilePath, formatOptions, preferences);
        }
        catch (_e) { }
        if (!(response === null || response === void 0 ? void 0 : response.length))
            return;
        const edits = (0, rename_1.fileTextChangesToWorkspaceEdit)(response, getTextDocument);
        return edits;
    });
}
exports.register = register;
//# sourceMappingURL=fileRename.js.map